## kupfer 0+v206+dfsg

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

# Kupfer's main wscript description file for Waf, written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

import os
import sys
try:
	from waflib import Configure, Options, Utils, Logs
except ImportError:
	print("You need to upgrade to Waf 1.6! See README.")
	sys.exit(1)

# the following two variables are used by the target "waf dist"
APPNAME="kupfer"
VERSION = "undefined"

def _get_git_version():
	""" try grab the current version number from git"""
	version = None
	if os.path.exists(".git"):
		try:
			version = os.popen("git describe").read().strip()
		except Exception as e:
			print(e)
	return version

def _read_git_version():
	"""Read version from git repo, or from GIT_VERSION"""
	version = _get_git_version()
	if not version and os.path.exists("GIT_VERSION"):
		f = open("GIT_VERSION", "r")
		version = f.read().strip()
		f.close()
	if version:
		global VERSION
		VERSION = version

def _write_git_version():
	""" Write the revision to a file called GIT_VERSION,
	to grab the current version number from git when
	generating the dist tarball."""
	version = _get_git_version()
	if not version:
		return False
	version_file = open("GIT_VERSION", "w")
	version_file.write(version + "\n")
	version_file.close()
	return True


_read_git_version()

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

config_subdirs = "auxdata extras help"
build_subdirs = "auxdata data po extras help"

EXTRA_DIST = [
	"waf",
	"GIT_VERSION",
]

def _tarfile_append_as(tarname, filename, destname):
	import tarfile
	tf = tarfile.TarFile.open(tarname, "a")
	try:
		tarinfo = tf.gettarinfo(name=filename, arcname=destname)
		tarinfo.uid = 0
		tarinfo.gid = 0
		tarinfo.uname = "root"
		tarinfo.gname = "root"
		with open(filename, "rb") as f:
			tf.addfile(tarinfo, f)
	finally:
		tf.close()

def gitdist(ctx):
	"""Make the release tarball using git-archive"""
	import subprocess
	if not _write_git_version():
		raise Exception("No version")
	basename = "%s-%s" % (APPNAME, VERSION)
	outname = basename + ".tar"
	proc = subprocess.Popen(
		["git", "archive", "--format=tar", "--prefix=%s/" % basename, "HEAD"],
		stdout=subprocess.PIPE)
	fd = os.open(outname, os.O_CREAT | os.O_EXCL | os.O_WRONLY, 0o666)
	os.write(fd, proc.communicate()[0])
	os.close(fd)
	for distfile in EXTRA_DIST:
		_tarfile_append_as(outname, distfile, os.path.join(basename, distfile))
	subprocess.call(["gzip", outname])
	subprocess.call(["sha1sum", outname + ".gz"])

def dist(ctx):
	"The standard waf dist process"
	import Scripting
	_write_git_version()
	Scripting.g_gz = "gz"
	Scripting.dist(ctx)


def options(opt):
	# options for disabling pyc or pyo compilation
	opt.tool_options("python")
	opt.tool_options("gnu_dirs")
	opt.add_option('--nopyo',action='store_false',default=False,help='Do not install optimised compiled .pyo files [This is the default for Kupfer]',dest='pyo')
	opt.add_option('--pyo',action='store_true',default=False,help='Install optimised compiled .pyo files [Default:not install]',dest='pyo')
	opt.add_option('--no-runtime-deps',action='store_false',default=True,
			help='Do not check for any runtime dependencies',dest='check_deps')
	opt.sub_options(config_subdirs)

def configure(conf):
	conf.check_tool("python")
	try:
		conf.check_python_version((2,6,0))
	except Configure.ConfigurationError:
		# with explicitly set python that is not found, we
		# must show an error
		if os.getenv("PYTHON"):
			raise
		conf.env["PYTHON"] = "python2.6"
		conf.check_python_version((2,6,0))
	conf.check_tool("gnu_dirs")

	conf.check_tool("intltool")

	conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
	conf.env["VERSION"] = VERSION
	conf.sub_config(config_subdirs)

	# Setup PYTHONDIR so we install into $DATADIR
	conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
	Logs.pprint("NORMAL",
			"Installing python modules into: %(PYTHONDIR)s" % conf.env)

	opt_build_programs = {
			"rst2man": "Generate and install man page",
		}
	for prog in opt_build_programs:
		try:
			conf.find_program(prog, var=prog.replace("-", "_").upper())
		except conf.errors.ConfigurationError:
			Logs.pprint("YELLOW",
			             "Optional, allows: %s" % opt_build_programs[prog])

	if not Options.options.check_deps:
		return

	python_modules = """
		gio
		gtk
		xdg
		dbus
		"""
	for module in python_modules.split():
		conf.check_python_module(module)

	Logs.pprint("NORMAL", "Checking optional dependencies:")

	opt_programs = {
			"dbus-send": "Focus kupfer from the command line",
		}
	opt_pymodules = {
			"wnck": "Identify and focus running applications",
			"gnome": ("Log out cleanly with session managers *OTHER* than "
				"gnome-session >= 2.24"),
			"keyring": "Required by plugins that save passwords",
		}

	for prog in opt_programs:
		try:
			conf.find_program(prog, var=prog.replace("-", "_").upper())
		except conf.errors.ConfigurationError:
			Logs.pprint("YELLOW", "Optional, allows: %s" % opt_programs[prog])

	try:
		conf.check_python_module("keybinder")
	except Configure.ConfigurationError:
		Logs.pprint("RED", "Python module keybinder is recommended")
		Logs.pprint("RED", "Please see README")
		
	for mod in opt_pymodules:
		try:
			conf.check_python_module(mod)
		except Configure.ConfigurationError:
			Logs.pprint("YELLOW", "module %s is recommended, allows %s" % (
				mod, opt_pymodules[mod]))


def _new_package(bld, name):
	"""Add module @name to sources to be installed,
	where the name is the full (relative) path to the package
	"""
	obj = bld.new_task_gen("py")
	node = bld.path.find_dir(name)
	obj.source = node.ant_glob("*.py")
	obj.install_path = "${PYTHONDIR}/%s" % name

	# Find embedded package datafiles
	pkgnode = bld.path.find_dir(name)

	bld.install_files(obj.install_path, pkgnode.ant_glob("icon-list"))
	bld.install_files(obj.install_path, pkgnode.ant_glob("*.png"))
	bld.install_files(obj.install_path, pkgnode.ant_glob("*.svg"))

def _find_packages_in_directory(bld, name):
	"""Go through directory @name and recursively add all
	Python packages with contents to the sources to be installed
	"""
	for dirname, dirs, filenames in os.walk(name):
		if "__init__.py" in filenames:
			_new_package(bld, dirname)

def _dict_slice(D, keys):
	return dict((k,D[k]) for k in keys)

def build(bld):
	# always read new version
	bld.env["VERSION"] = VERSION

	# kupfer/
	# kupfer module version info file
	version_subst_file = "kupfer/version_subst.py"
	bld(features="subst",
		source=version_subst_file + ".in",
		target=version_subst_file,
		dict = _dict_slice(bld.env,"VERSION DATADIR PACKAGE LOCALEDIR".split())
		)
	bld.install_files("${PYTHONDIR}/kupfer", "kupfer/version_subst.py")

	bld.new_task_gen(
		source="kupfer.py",
		install_path="${PYTHONDIR}"
		)

	# Add all Python packages recursively
	_find_packages_in_directory(bld, "kupfer")

	# bin/
	# Write in some variables in the shell script binaries
	bld(features="subst",
		source = "bin/kupfer.in",
		target = "bin/kupfer",
		dict = _dict_slice(bld.env, "PYTHON PYTHONDIR".split())
		)
	bld.install_files("${BINDIR}", "bin/kupfer", chmod=0o755)

	bld(features="subst",
		source = "bin/kupfer-exec.in",
		target = "bin/kupfer-exec",
		dict = _dict_slice(bld.env, "PYTHON PACKAGE LOCALEDIR".split())
		)
	bld.install_files("${BINDIR}", "bin/kupfer-exec", chmod=0o755)

	# Documentation/
	if bld.env["RST2MAN"]:
		# generate man page from Manpage.rst
		bld.new_task_gen(
			source = "Documentation/Manpage.rst",
			target = "kupfer.1",
			rule = '%s ${SRC} > ${TGT}' % bld.env["RST2MAN"],
		)
		bld.add_group()
		# compress and install man page
		manpage = bld.new_task_gen(
			source = "kupfer.1",
			target = "kupfer.1.gz",
			rule = 'gzip -9 -c ${SRC} > ${TGT}',
			install_path = "${MANDIR}/man1",
		)
		man_path = Utils.subst_vars(
				os.path.join(manpage.install_path, manpage.target),
				bld.env)
		bld.symlink_as("${MANDIR}/man1/kupfer-exec.1.gz", man_path)

	# Separate subdirectories
	bld.add_subdirs(build_subdirs)

def intlupdate(util):
	print("You should use intltool-update directly.")
	print("You can read about this in Documentation/Manual.rst")
	print("in the localization chapter!")

def test(bld):
	# find all files with doctests
	python = os.getenv("PYTHON", "python")
	paths = os.popen("grep -lR 'doctest.testmod()' kupfer/").read().split()
	os.putenv("PYTHONPATH", ".")
	all_success = True
	verbose = ("-v" in sys.argv)
	for p in paths:
		print(p)
		cmd = [python, p]
		if verbose:
			cmd.append("-v")
		sin, souterr = os.popen4(cmd)
		sin.close()
		res = souterr.read()
		souterr.close()
		print (res or "OK")
		all_success = all_success and bool(res)
	return all_success

def shutdown(bld):
	pass

=== debian/changelog ===
kupfer (0+v206+dfsg-1ubuntu1) precise; urgency=low

  * kupfer/dbuscompat.py
    - copied gobject_service.py verbatim from dbus-python version 0.84.0 to 
      kupfer/dbuscompat.py (LP: #921829) 

 -- Vibhav Pant <vibhavp@gmail.com>  Sat, 24 Mar 2012 21:11:51 +0530

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Luca Falavigna <dktrkranz@debian.org>
Uploaders: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: python (>= 2.6.6-3~), gettext, intltool, gnome-doc-utils, python-docutils
Standards-Version: 3.9.2
X-Python-Version: >= 2.6
Homepage: http://kaizer.se/wiki/kupfer/
Vcs-Svn: svn://svn.debian.org/python-apps/packages/kupfer/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/python-apps/packages/kupfer/trunk/

Package: kupfer
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-gobject (>= 2.18), python-gtk2 (>= 2.16), python-xdg, python-dbus, dbus, python-keybinder
Recommends: python-keyring, python-wnck
Suggests: python-cjson, python-gdata, python-qrencode
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 . 
 Kupfer is written in Python and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
#!/usr/bin/make -f

VERSION = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//')
UPSTREAM = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//;s/^0+//')

%:
	dh $@ --with python2

clean:
	./waf distclean
	rm -fr build
	dh $@ Documentation/*.html
	find waflib -name "*.pyc" -delete

override_dh_auto_configure:
	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --nopyc --nopyo \
		--bindir=/usr/share/kupfer --no-runtime-deps --no-install-nautilus-extension

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/kupfer
	install -m 0755 $(CURDIR)/build/bin/kupfer $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer-activate.sh
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer/kupfer
	rm -f $(CURDIR)/debian/kupfer/usr/share/gnome/help/kupfer/*/license.page
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/art/COPYING
	make -C Documentation
	rst2man Documentation/Manpage.rst build/kupfer.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/kupfer/usr/share/kupfer/kupfer.py

get-orig-source:
	tar fxz ../kupfer_${VERSION}.orig.tar.gz -C ../
	cd ../kupfer-${UPSTREAM} && ./waf --version && \
	mv .waf-*/waflib waflib && sed -i '/^#==>$$/,$$d' waf \
	&& rmdir .waf-* && find waflib -name "*.pyc" -delete
	tar czf ../kupfer_${VERSION}+dfsg.orig.tar.gz ../kupfer-${UPSTREAM}
	rm -fr ../kupfer-${UPSTREAM}

=== debian/watch ===
version=3
opts=uversionmangle=s/^/0\+/,dversionmangle=s/\+dfsg// \
http://kaizer.se/publicfiles/kupfer/kupfer-(.*)\.tar\.gz

## kupfer 0+v207

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: kupfer
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Luca Falavigna <dktrkranz@debian.org>
+Maintainer: Luca Falavigna <dktrkranz@debian.org>
 Uploaders: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Build-Depends: debhelper (>= 7.0.50~)
 Build-Depends-Indep: python (>= 2.6.6-3~), gettext, intltool, gnome-doc-utils, python-docutils
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 X-Python-Version: >= 2.6
 Homepage: http://kaizer.se/wiki/kupfer/
 Vcs-Svn: svn://svn.debian.org/python-apps/packages/kupfer/trunk/

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,4 @@
 #!/usr/bin/make -f
-
-VERSION = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//')
-UPSTREAM = $(shell head -n1 debian/changelog | sed -e 's/.*(//;s/-.*).*//;s/^0+//')
 
 %:
 	dh $@ --with python2
@@ -31,11 +28,3 @@
 override_dh_fixperms:
 	dh_fixperms
 	chmod +x debian/kupfer/usr/share/kupfer/kupfer.py
-
-get-orig-source:
-	tar fxz ../kupfer_${VERSION}.orig.tar.gz -C ../
-	cd ../kupfer-${UPSTREAM} && ./waf --version && \
-	mv .waf-*/waflib waflib && sed -i '/^#==>$$/,$$d' waf \
-	&& rmdir .waf-* && find waflib -name "*.pyc" -delete
-	tar czf ../kupfer_${VERSION}+dfsg.orig.tar.gz ../kupfer-${UPSTREAM}
-	rm -fr ../kupfer-${UPSTREAM}

## kupfer 0+v208

=== wscript ===
--- 
+++ 
@@ -60,7 +60,7 @@
 build_subdirs = "auxdata data po extras help"
 
 EXTRA_DIST = [
-	"waf",
+	#"waf",
 	"GIT_VERSION",
 ]
 
@@ -93,8 +93,8 @@
 	os.close(fd)
 	for distfile in EXTRA_DIST:
 		_tarfile_append_as(outname, distfile, os.path.join(basename, distfile))
-	subprocess.call(["gzip", outname])
-	subprocess.call(["sha1sum", outname + ".gz"])
+	subprocess.call(["xz", "-6e", outname])
+	subprocess.call(["sha1sum", outname + ".xz"])
 
 def dist(ctx):
 	"The standard waf dist process"
@@ -280,6 +280,9 @@
 
 	# Separate subdirectories
 	bld.add_subdirs(build_subdirs)
+
+def distclean(bld):
+	bld.exec_command("find ./ -name '*.pyc' -delete")
 
 def intlupdate(util):
 	print("You should use intltool-update directly.")

=== Documentation/Makefile ===
#  This makefile can generate html versions that are pleasant to read
#  needs python-docutils

all: Contributing.html Copyright.html Localization.html Manpage.html \
	Manual.html PluginAPI.html \
	GTKTheming.html VersionHistory.html

%.html: %.rst
	rst2html $^ > $@

%.pdf: %.rst
	rst2pdf -o $@ $^

=== auxdata/wscript ===
#! /usr/bin/env python
import os

from waflib import Options, Utils, Logs

def options(opt):
	opt.add_option('--no-update-mime',
			action='store_true',
			default=False,
			help='Do not update mime and desktop databases [Default:Update]')
	opt.add_option('--no-update-icon-cache',
			action='store_true',
			default=False,
			help='Do not update icon cache [Default:Update]')

def configure(conf):
	if not Options.options.no_update_mime:
		conf.env["AUXDATA_MIME"] = 1
	if not Options.options.no_update_icon_cache:
		conf.env["UPDATE_ICON_CACHE"] = 1


def build(bld):
	# merge translations into the .desktop file
	# and set it up to be installed
	def install_desktop_file(desktop_subst_file):
		return bld(
			features="intltool_in",
			podir="../po",
			flags = ("-d", "-q", "-u", "-c"),
			source = desktop_subst_file  + ".in",
			target = desktop_subst_file,
			install_path = "${DATADIR}/applications",
			chmod = 0o755,
		)

	k_desktop = install_desktop_file("kupfer.desktop")
	x_desktop = install_desktop_file("kupfer-exec.desktop")

	## install kupfer.desktop as a Thunar sendto object
	kd_install = os.path.join(
		Utils.subst_vars(k_desktop.install_path, bld.env), "kupfer.desktop")
	symlink_location = \
		Utils.subst_vars("${DATADIR}/Thunar/sendto/kupfer.desktop", bld.env)
	symlink_target = \
		os.path.relpath(kd_install, os.path.dirname(symlink_location))
	bld.symlink_as(symlink_location, symlink_target)

	## install mimetype descriptions

	mimetypes_file = "kupfer-mimetypes.xml"
	bld(
		features="intltool_in",
		podir="../po",
		flags = ("-x", "-q", "-u", "-c"),
		source = mimetypes_file  + ".in",
		target = mimetypes_file,
		install_path = "${DATADIR}/mime/packages/",
	)


	def update_mime(bld):
		Logs.pprint('GREEN',"Updating mime database")
		bld.exec_command(["update-mime-database",
				Utils.subst_vars("${DATADIR}/mime", bld.env)])
		bld.exec_command(["update-desktop-database",
				Utils.subst_vars("${DATADIR}/applications", bld.env)])

	if bld.is_install and bld.env["AUXDATA_MIME"]:
		bld.add_post_fun(update_mime)

	## install kupfer.svg icon
	icons_inst = bld.install_files("${DATADIR}/icons/hicolor/scalable/apps",
	                               "kupfer.svg")

	def update_icon_cache(bld):
		icon_dir = Utils.subst_vars('${DATADIR}/icons/hicolor', bld.env)
		if not Options.options.destdir:
			Logs.pprint('GREEN',"Updating Gtk icon cache.")
			command='gtk-update-icon-cache -q -f -t %s' % icon_dir
			bld.exec_command(command)
		else:
			Logs.pprint('YELLOW','Icon cache not updated. After install, run this:')
			Logs.pprint('YELLOW','gtk-update-icon-cache -q -f -t %s'%icon_dir)

	if icons_inst and bld.is_install and bld.env["UPDATE_ICON_CACHE"]:
		bld.add_post_fun(update_icon_cache)

=== extras/wscript ===
import Options, Utils
import os

def options(opt):
	opt.add_option('--no-install-nautilus-extension',
			action='store_true',
			default=False,
			help='Install Kupfer Nautilus Extension [Default:Install]')

def configure(conf):
	if Options.options.no_install_nautilus_extension:
		return
	libdir = Utils.subst_vars("${LIBDIR}", conf.env)
	if libdir.startswith(os.path.expanduser("~/")):
		NAUTILUS_EXT_LIBDIR=os.path.expanduser("~/.nautilus/python-extensions/")
	else:
		NAUTILUS_EXT_LIBDIR=os.path.join(libdir, "nautilus", "extensions-2.0",
				"python")
	conf.env["NAUTILUS_EXT_LIBDIR"] = NAUTILUS_EXT_LIBDIR

def build(bld):
	if not bld.env["NAUTILUS_EXT_LIBDIR"]:
		return
	bld.install_files("${NAUTILUS_EXT_LIBDIR}", "kupfer_provider.py")

=== help/wscript ===
#!/usr/bin/env python

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
from waflib import Task, TaskGen, Utils

# FIXME: Support for figures

def _read_makefile_am(filename):
	"read a Makefile.am file for DOC_* variable definitions, return a dict"
	varstring = open(filename).read()
	varstring = varstring.replace("\\\n", " ")
	varlines = [L for L in varstring.splitlines() if L.startswith("DOC")]
	return dict(tuple(map(str.strip, var.split("=", 1))) for var in varlines)

def init_mallard(self):
	mf_am = self.path.find_resource(self.variable_definitions)
	DOC_VAR = _read_makefile_am(mf_am.abspath())

	require_vars = "DOC_ID DOC_LINGUAS DOC_PAGES".split()
	have_vars = set(var for var in DOC_VAR if DOC_VAR[var])
	missing_vars = set(require_vars).difference(have_vars)
	if missing_vars:
		print("Missing DOC variable declarations in %s:" % (mf_am.abspath()))
		print("\n".join(missing_vars))

	self.bld.env.update(DOC_VAR)
	self.default_install_path='${PREFIX}/share/gnome/help/${DOC_ID}'

def apply_mallard(self):
	bld = self.bld
	lst = self.to_list(bld.env["DOC_LINGUAS"])
	cnode = self.path.find_dir("C")

	pages = cnode.ant_glob("*.page")
	self.install_path = Utils.subst_vars(self.default_install_path, self.env)

	# Check if the declared page list is consistent
	declared_pages = self.to_list(bld.env["DOC_PAGES"])
	missing_pages = set([str(p) for p in pages]).difference(declared_pages)
	if missing_pages:
		print("Warning: Some pages not declared:")
		print("\n".join([str(p) for p in missing_pages]))

	for lang in lst:
		node = self.path.find_resource("%s/%s.po" % (lang, lang))
		for page in pages:
			tsk = self.create_task('xml2po')
			out = self.path.find_or_declare('%s/%s' % (lang, page))
			src = self.path.find_resource('C/%s' % page)
			tsk.set_inputs([node,src])
			tsk.set_outputs(out)
			bld.install_files(os.path.join(self.install_path, lang),
			                  tsk.outputs)
	for page in pages:
		instdir = os.path.join(self.install_path, "C")
		bld.install_files(instdir, page)

Task.simple_task_type('xml2po', '${XML2PO} ${XML2POFLAGS} ${SRC} > ${TGT}',
		color='BLUE')

TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after('init_mallard')(apply_mallard)

## End Mallard functionality ##


# Build Configuration

def options(opt):
	pass

def configure(ctx):
	try:
		ctx.find_program('xml2po', var='XML2PO')
		ctx.env['XML2POFLAGS'] = '-mmallard -p'
	except ctx.errors.ConfigurationError:
		pass

def build(bld):
	if bld.env["XML2PO"]:
		task = bld(features="mallard",
			variable_definitions="Makefile.am",
		)

=== po/wscript ===
def build(bld):
    bld.new_task_gen(
        features = 'intltool_po',
        appname = bld.env["PACKAGE"])

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Hugo Lefeuvre <hugo6390@orange.fr>,
Build-Depends: debhelper (>= 9)
Build-Depends-Indep: gettext,
                     gnome-doc-utils,
                     intltool,
                     python (>= 2.6.6-3~),
                     python-docutils
Standards-Version: 3.9.5
X-Python-Version: >= 2.6
Homepage: http://engla.github.io/kupfer/
Vcs-Svn: svn://anonscm.debian.org/python-apps/packages/kupfer/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/python-apps/packages/kupfer/trunk/

Package: kupfer
Architecture: all
Depends: dbus,
         python-dbus,
         python-gobject (>= 2.18),
         python-gtk2 (>= 2.16),
         python-keybinder,
         python-xdg,
         ${misc:Depends},
         ${python:Depends}
Recommends: python-keyring, python-wnck
Suggests: python-cjson, python-gdata, python-qrencode
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,10 @@
 
 clean:
 	./waf distclean
-	rm -fr build
-	dh $@ Documentation/*.html
+	rm -fr build .lock-waf* po/.intlcache
+	find Documentation -name "*.html" -delete
 	find waflib -name "*.pyc" -delete
+	dh $@
 
 override_dh_auto_configure:
 	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --nopyc --nopyo \

## kupfer 0+v319

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

# Kupfer's main wscript description file for Waf, written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

import os
import sys
try:
    from waflib import Configure, Options, Utils, Logs
except ImportError:
    print("You need to upgrade to Waf 1.6! See README.")
    sys.exit(1)

# the following two variables are used by the target "waf dist"
APPNAME="kupfer"
VERSION = "undefined"

def _get_git_version():
    """ try grab the current version number from git"""
    version = None
    if os.path.exists(".git"):
        try:
            version = os.popen("git describe").read().strip()
        except Exception as e:
            print(e)
    return version

def _read_git_version():
    """Read version from git repo, or from GIT_VERSION"""
    version = _get_git_version()
    if not version and os.path.exists("GIT_VERSION"):
        f = open("GIT_VERSION", "r")
        version = f.read().strip()
        f.close()
    if version:
        global VERSION
        VERSION = version

def _write_git_version():
    """ Write the revision to a file called GIT_VERSION,
    to grab the current version number from git when
    generating the dist tarball."""
    version = _get_git_version()
    if not version:
        return False
    version_file = open("GIT_VERSION", "w")
    version_file.write(version + "\n")
    version_file.close()
    return True


_read_git_version()

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

config_subdirs = "auxdata help"
build_subdirs = "auxdata data po help"

EXTRA_DIST = [
    #"waf",
    "GIT_VERSION",
]

def _tarfile_append_as(tarname, filename, destname):
    import tarfile
    tf = tarfile.TarFile.open(tarname, "a")
    try:
        tarinfo = tf.gettarinfo(name=filename, arcname=destname)
        tarinfo.uid = 0
        tarinfo.gid = 0
        tarinfo.uname = "root"
        tarinfo.gname = "root"
        with open(filename, "rb") as f:
            tf.addfile(tarinfo, f)
    finally:
        tf.close()

def gitdist(ctx):
    """Make the release tarball using git-archive"""
    import subprocess
    if not _write_git_version():
        raise Exception("No version")
    basename = "%s-%s" % (APPNAME, VERSION)
    outname = basename + ".tar"
    proc = subprocess.Popen(
        ["git", "archive", "--format=tar", "--prefix=%s/" % basename, "HEAD"],
        stdout=subprocess.PIPE)
    fd = os.open(outname, os.O_CREAT | os.O_EXCL | os.O_WRONLY, 0o666)
    os.write(fd, proc.communicate()[0])
    os.close(fd)
    for distfile in EXTRA_DIST:
        _tarfile_append_as(outname, distfile, os.path.join(basename, distfile))
    subprocess.call(["xz", "-6e", outname])
    subprocess.call(["sha1sum", outname + ".xz"])

def dist(ctx):
    "The standard waf dist process"
    import Scripting
    _write_git_version()
    Scripting.g_gz = "gz"
    Scripting.dist(ctx)


def options(opt):
    # options for disabling pyc or pyo compilation
    opt.load("python")
    opt.load("gnu_dirs")
    opt.add_option('--nopyo',action='store_false',default=False,help='Do not install optimised compiled .pyo files [This is the default for Kupfer]',dest='pyo')
    opt.add_option('--pyo',action='store_true',default=False,help='Install optimised compiled .pyo files [Default:not install]',dest='pyo')
    opt.add_option('--no-runtime-deps',action='store_false',default=True,
            help='Do not check for any runtime dependencies',dest='check_deps')
    opt.recurse(config_subdirs)

def configure(conf):
    conf.load("python")
    try:
        conf.check_python_version((3, 5, 0))
    except Configure.ConfigurationError:
        if os.getenv("PYTHON"):
            raise
        Logs.pprint("NORMAL", "Looking for Python 3 instead")
        conf.env["PYTHON"] = ["python3"]
        conf.check_python_version((3, 5, 0))
    conf.load("gnu_dirs")

    conf.load("intltool")

    conf.env["KUPFER"] = Utils.subst_vars("${BINDIR}/kupfer", conf.env)
    conf.env["VERSION"] = VERSION
    conf.recurse(config_subdirs)

    # Setup PYTHONDIR so we install into $DATADIR
    conf.env["PYTHONDIR"] = Utils.subst_vars("${DATADIR}/kupfer", conf.env)
    Logs.pprint("NORMAL",
            "Installing python modules into: %(PYTHONDIR)s" % conf.env)

    opt_build_programs = {
            "rst2man": "Generate and install man page",
        }
    for prog in opt_build_programs:
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW",
                         "Optional, allows: %s" % opt_build_programs[prog])

    if not Options.options.check_deps:
        return

    python_modules = """
        gi.repository.Gtk
        xdg
        dbus
        """
    for module in python_modules.split():
        conf.check_python_module(module)

    Logs.pprint("NORMAL", "Checking optional dependencies:")

    opt_programs = {
            "dbus-send": "Focus kupfer from the command line",
        }
    opt_pymodules = {
        "gi.repository.Wnck": "Jump to running applications and list windows",
        "gi.repository.Keybinder": "Register global keybindings",
    }

    for prog in opt_programs:
        try:
            conf.find_program(prog, var=prog.replace("-", "_").upper())
        except conf.errors.ConfigurationError:
            Logs.pprint("YELLOW", "Optional, allows: %s" % opt_programs[prog])

    for mod in opt_pymodules:
        try:
            conf.check_python_module(mod)
        except Configure.ConfigurationError:
            Logs.pprint("YELLOW", "module %s is recommended, allows %s" % (
                mod, opt_pymodules[mod]))


def _new_package(bld, name):
    """Add module @name to sources to be installed,
    where the name is the full (relative) path to the package
    """
    obj = bld("py")
    node = bld.path.find_dir(name)
    obj.source = node.ant_glob("*.py")
    obj.install_path = "${PYTHONDIR}/%s" % name

    # Find embedded package datafiles
    pkgnode = bld.path.find_dir(name)

    bld.install_files(obj.install_path, pkgnode.ant_glob("icon-list"))
    bld.install_files(obj.install_path, pkgnode.ant_glob("*.png"))
    bld.install_files(obj.install_path, pkgnode.ant_glob("*.svg"))

def _find_packages_in_directory(bld, name):
    """Go through directory @name and recursively add all
    Python packages with contents to the sources to be installed
    """
    for dirname, dirs, filenames in os.walk(name):
        if "__init__.py" in filenames:
            _new_package(bld, dirname)

def _dict_slice(D, keys):
    return dict((k,D[k]) for k in keys)

def build(bld):
    # always read new version
    bld.env["VERSION"] = VERSION

    # kupfer/
    # kupfer module version info file
    version_subst_file = "kupfer/version_subst.py"
    bld(features="subst",
        source=version_subst_file + ".in",
        target=version_subst_file,
        dict = _dict_slice(bld.env,"VERSION DATADIR PACKAGE LOCALEDIR".split())
        )
    bld.install_files("${PYTHONDIR}/kupfer", "kupfer/version_subst.py")

    bld(
        source="kupfer.py",
        install_path="${PYTHONDIR}"
        )

    # Add all Python packages recursively
    _find_packages_in_directory(bld, "kupfer")

    # bin/
    # Write in some variables in the shell script binaries
    bld(features="subst",
        source = "bin/kupfer.in",
        target = "bin/kupfer",
        dict = _dict_slice(bld.env, "PYTHON PYTHONDIR".split())
        )
    bld.install_files("${BINDIR}", "bin/kupfer", chmod=0o755)

    bld(features="subst",
        source = "bin/kupfer-exec.in",
        target = "bin/kupfer-exec",
        dict = _dict_slice(bld.env, "PYTHON PACKAGE LOCALEDIR".split())
        )
    bld.install_files("${BINDIR}", "bin/kupfer-exec", chmod=0o755)

    # Documentation/
    if bld.env["RST2MAN"]:
        # generate man page from Manpage.rst
        bld(
            source = "Documentation/Manpage.rst",
            target = "kupfer.1",
            rule = '%s ${SRC} > ${TGT}' % bld.env["RST2MAN"],
        )
        bld.add_group()
        # compress and install man page
        manpage = bld(
            source = "kupfer.1",
            target = "kupfer.1.gz",
            rule = 'gzip -9 -c ${SRC} > ${TGT}',
            install_path = "${MANDIR}/man1",
        )
        man_path = Utils.subst_vars(
                os.path.join(manpage.install_path, manpage.target),
                bld.env)
        bld.symlink_as("${MANDIR}/man1/kupfer-exec.1.gz", man_path)

    # Separate subdirectories
    bld.recurse(build_subdirs)

def distclean(bld):
    bld.exec_command("find ./ -name '*.pyc' -delete")

def intlupdate(util):
    print("You should use intltool-update directly.")
    print("You can read about this in Documentation/Manual.rst")
    print("in the localization chapter!")

def test(bld):
    # find all files with doctests
    python = os.getenv("PYTHON", "python")
    paths = os.popen("grep -lR 'doctest.testmod()' kupfer/").read().split()
    os.putenv("PYTHONPATH", ".")
    all_success = True
    verbose = ("-v" in sys.argv)
    for p in paths:
        print(p)
        cmd = [python, p]
        if verbose:
            cmd.append("-v")
        sin, souterr = os.popen4(cmd)
        sin.close()
        res = souterr.read()
        souterr.close()
        print (res or "OK")
        all_success = all_success and bool(res)
    return all_success

def shutdown(bld):
    pass

=== auxdata/wscript ===
#! /usr/bin/env python
import os

from waflib import Options, Utils, Logs

def options(opt):
    opt.add_option('--no-hooks',
            action='store_true',
            default=False,
            help="Don't run any mime, icon cache or similar update hooks [Default:False]")
    opt.add_option('--no-update-mime',
            action='store_true',
            default=False,
            help='Do not update mime and desktop databases [Default:Update]')
    opt.add_option('--no-update-icon-cache',
            action='store_true',
            default=False,
            help='Do not update icon cache [Default:Update]')

def configure(conf):
    if not Options.options.no_update_mime and not Options.options.no_hooks:
        conf.env["AUXDATA_MIME"] = 1
    if not Options.options.no_update_icon_cache and not Options.options.no_hooks:
        conf.env["UPDATE_ICON_CACHE"] = 1


def build(bld):
    # merge translations into the .desktop file
    # and set it up to be installed
    def install_desktop_file(desktop_subst_file):
        return bld(
            features="intltool_in",
            podir="../po",
            flags = ("-d", "-q", "-u", "-c"),
            source = desktop_subst_file  + ".in",
            target = desktop_subst_file,
            install_path = "${DATADIR}/applications",
            chmod = 0o755,
        )

    k_desktop = install_desktop_file("kupfer.desktop")
    x_desktop = install_desktop_file("kupfer-exec.desktop")

    ## install kupfer.desktop as a Thunar sendto object
    kd_install = os.path.join(
        Utils.subst_vars(k_desktop.install_path, bld.env), "kupfer.desktop")
    symlink_location = \
        Utils.subst_vars("${DATADIR}/Thunar/sendto/kupfer.desktop", bld.env)
    symlink_target = \
        os.path.relpath(kd_install, os.path.dirname(symlink_location))
    bld.symlink_as(symlink_location, symlink_target)

    ## install mimetype descriptions

    mimetypes_file = "kupfer-mimetypes.xml"
    bld(
        features="intltool_in",
        podir="../po",
        flags = ("-x", "-q", "-u", "-c"),
        source = mimetypes_file  + ".in",
        target = mimetypes_file,
        install_path = "${DATADIR}/mime/packages/",
    )


    def update_mime(bld):
        Logs.pprint('GREEN',"Updating mime database")
        bld.exec_command(["update-mime-database",
                Utils.subst_vars("${DATADIR}/mime", bld.env)])
        bld.exec_command(["update-desktop-database",
                Utils.subst_vars("${DATADIR}/applications", bld.env)])

    if bld.is_install and bld.env["AUXDATA_MIME"]:
        bld.add_post_fun(update_mime)


    ## install kupfer icon
    icons_inst = bld.install_files("${DATADIR}/icons/hicolor",
                                   bld.path.ant_glob("hicolor/**"),
                                   cwd=bld.path.find_dir("hicolor"),
                                   relative_trick=True)

    def update_icon_cache(bld):
        icon_dir = Utils.subst_vars('${DATADIR}/icons/hicolor', bld.env)
        if not Options.options.destdir:
            Logs.pprint('GREEN',"Updating Gtk icon cache.")
            command='gtk-update-icon-cache -q -f -t %s' % icon_dir
            bld.exec_command(command)
        else:
            Logs.pprint('YELLOW','Icon cache not updated. After install, run this:')
            Logs.pprint('YELLOW','gtk-update-icon-cache -q -f -t %s'%icon_dir)

    if icons_inst and bld.is_install and bld.env["UPDATE_ICON_CACHE"]:
        bld.add_post_fun(update_icon_cache)

=== help/Makefile ===
#  This makefile is for convenience.
#
#  Run 'make' to build HTML documentation in the C directory
#  Run 'make $LANG' to update the translation file for language $LANG
#
#  To add a new language, edit Makefile.am

include Makefile.am

C:
	make -C C


$(DOC_LINGUAS): C/*.page
	xml2po -mmallard -u "$@/$@.po" C/*.page


html:
	for lang in C $(DOC_LINGUAS) ; do \
		rm -r $$lang ; \
		mkdir $$lang ; \
		yelp-build html -o $$lang /usr/share/help/$$lang/kupfer ; \
	done

=== help/wscript ===
#!/usr/bin/env python

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
from waflib import Task, TaskGen, Utils

# FIXME: Support for figures

def _read_makefile_am(filename):
    "read a Makefile.am file for DOC_* variable definitions, return a dict"
    varstring = open(filename).read()
    varstring = varstring.replace("\\\n", " ")
    varlines = [L for L in varstring.splitlines() if L.startswith("DOC")]
    return dict(tuple(map(str.strip, var.split("=", 1))) for var in varlines)

def init_mallard(self):
    mf_am = self.path.find_resource(self.variable_definitions)
    DOC_VAR = _read_makefile_am(mf_am.abspath())

    require_vars = "DOC_ID DOC_LINGUAS DOC_PAGES".split()
    have_vars = set(var for var in DOC_VAR if DOC_VAR[var])
    missing_vars = set(require_vars).difference(have_vars)
    if missing_vars:
        print("Missing DOC variable declarations in %s:" % (mf_am.abspath()))
        print("\n".join(missing_vars))

    self.bld.env.update(DOC_VAR)
    self.help_install_prefix='${PREFIX}/share/help/'

def apply_mallard(self):
    bld = self.bld
    lst = self.to_list(bld.env["DOC_LINGUAS"])
    cnode = self.path.find_dir("C")

    pages = cnode.ant_glob("*.page")
    legal_xml = cnode.ant_glob("legal.xml")
    self.install_path = Utils.subst_vars(self.help_install_prefix, self.env)

    # Check if the declared page list is consistent
    declared_pages = self.to_list(bld.env["DOC_PAGES"])
    missing_pages = set([str(p) for p in pages]).difference(declared_pages)
    if missing_pages:
        print("Warning: Some pages not declared:")
        print("\n".join([str(p) for p in missing_pages]))

    for lang in lst:
        lang_install_path = os.path.join(self.install_path, lang, bld.env["DOC_ID"])
        node = self.path.find_resource("%s/%s.po" % (lang, lang))
        for page in pages:
            tsk = self.create_task('xml2po')
            out = self.path.find_or_declare('%s/%s' % (lang, page))
            src = self.path.find_resource('C/%s' % page)
            tsk.set_inputs([node,src])
            tsk.set_outputs(out)
            bld.install_files(lang_install_path, tsk.outputs)
        bld.install_files(lang_install_path, legal_xml)

    c_install_path = os.path.join(self.install_path, "C", bld.env["DOC_ID"])
    for page in pages:
        bld.install_files(c_install_path, page)
    bld.install_files(c_install_path, legal_xml)

Task.task_factory('xml2po', '${XML2PO} ${XML2POFLAGS} ${SRC} > ${TGT}',
        color='BLUE')

TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after('init_mallard')(apply_mallard)

## End Mallard functionality ##


# Build Configuration

def options(opt):
    pass

def configure(ctx):
    try:
        ctx.find_program('xml2po', var='XML2PO')
        ctx.env['XML2POFLAGS'] = '-mmallard -p'
    except ctx.errors.ConfigurationError:
        pass

def build(bld):
    if bld.env["XML2PO"]:
        task = bld(features="mallard",
            variable_definitions="Makefile.am",
        )

=== po/wscript ===
def build(bld):
    bld(
        features = 'intltool_po',
        appname = bld.env["PACKAGE"])

=== help/C/Makefile ===
pages=$(wildcard *.page plugin/*.page)
htmls=$(patsubst %.page,%.html,$(pages))

all: $(htmls) index.cache

index.cache : $(pages)
	echo '<cache:cache xmlns:cache="http://projectmallard.org/cache/1.0/"' >$@.in
	echo '             xmlns="http://projectmallard.org/1.0/">'           >> $@.in
	for page in $(pages); do \
		echo "<page cache:href='$$page'/>" >> $@.in; \
	done
	echo '</cache:cache>' >> $@.in
	xsltproc `pkg-config --variable xsltdir gnome-doc-utils`/mallard/cache/mal-cache.xsl $@.in | xmllint --format - > $@
	rm $@.in

$(htmls) : index.cache
$(htmls) : %.html : %.page
	xsltproc \
	  --stringparam mal.cache.file `pwd`/index.cache \
	  --param mal.chunk.chunk_top 1 \
	  `pkg-config --variable mal2html gnome-doc-utils` $<

.PHONY: clean
clean:
	rm -fv index.cache *.html

=== debian/control ===
Source: kupfer
Section: utils
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders: Hugo Lefeuvre <hle@debian.org>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Indep: dh-python,
                     gettext,
                     gnome-doc-utils,
                     intltool,
                     python3-all,
                     python3-docutils
Standards-Version: 4.4.0
Homepage: https://kupferlauncher.github.io/
Vcs-Git: https://salsa.debian.org/python-team/applications/kupfer.git
Vcs-Browser: https://salsa.debian.org/python-team/applications/kupfer

Package: kupfer
Architecture: all
Depends: gir1.2-gtk-3.0,
         gir1.2-keybinder-3.0,
         python3-dbus,
         python3-gi-cairo,
         python3-xdg,
         ${misc:Depends},
         ${python3:Depends}
Recommends: gir1.2-wnck-3.0 (>= 3.20),
            yelp
Suggests: gir1.2-ayatanaappindicator3-0.1,
          python3-setproctitle
Description: fast and lightweight desktop summoner/launcher
 Kupfer is a summoner/launcher in the style of Quicksilver or GNOME Do. It
 can search and browse your files, launch desired applications and object you
 need in a quicker way.
 .
 Kupfer is written in Python 3 and has a flexible architecture based on plugins
 to extend its features.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

clean:
	./waf distclean
	rm -fr build .lock-waf* po/.intlcache
	find Documentation -name "*.html" -delete
	find waflib -name "*.pyc" -delete
	dh $@

override_dh_auto_configure:
	PYTHONDIR=/usr/share/kupfer ./waf configure --prefix=/usr --nopyc --nopyo \
		--bindir=/usr/share/kupfer --no-runtime-deps

override_dh_auto_install:
	./waf install --destdir=$(CURDIR)/debian/kupfer
	install -m 0755 $(CURDIR)/build/bin/kupfer $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer-activate.sh
	mkdir -p $(CURDIR)/debian/kupfer/usr/share/icons/hicolor/16x16/apps/
	install -m 0644 $(CURDIR)/debian/hicolor/16x16/apps/kupfer.png \
                $(CURDIR)/debian/kupfer/usr/share/icons/hicolor/16x16/apps/kupfer.png
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/kupfer/kupfer
	rm -f $(CURDIR)/debian/kupfer/usr/share/gnome/help/kupfer/*/license.page
	rm -f $(CURDIR)/debian/kupfer/usr/share/kupfer/art/COPYING

override_dh_installdocs:
	make -C Documentation
	dh_installdocs

override_dh_installman:
	rst2man Documentation/Manpage.rst build/kupfer.1
	dh_installman build/kupfer.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=3
opts=uversionmangle=s/^/0\+/ \
https://github.com/engla/kupfer/tags .*/(v\d[\d\.]+)
